### Method

# Vips Image convsep

#### Declaration [src]

    int
    vips_convsep (
      VipsImage* in,
      VipsImage** out,
      VipsImage* mask,
      ...
    )

#### Description [src]

Perform a separable convolution of `in` with `mask`. See `vips_conv()` for a detailed description.

The mask must be 1xn or nx1 elements.

The image is convolved twice: once with `mask` and then again with `mask` rotated by 90 degrees. This is much faster for certain types of mask (gaussian blur, for example) than doing a full 2D convolution.

Optional arguments

- `precision`: `VipsPrecision`, calculation accuracy
- `layers`: `gint`, number of layers for approximation
- `cluster`: `gint`, cluster lines closer than this distance

See also

`vips_conv()`, `vips_gaussmat()`.

This method is not directly available to language bindings.

#### Parameters

`out`

  Type: `VipsImage`

  Output image.

  The argument will be set by the function.
  The caller of the method takes ownership of the returned data, and is responsible for freeing it.

`mask`

  Type: `VipsImage`

  Convolution mask.

  The data is owned by the caller of the method.

`...`

  Type: ``

  `NULL`-terminated list of optional named arguments.

#### Return value

Type: `int`

0 on success, -1 on error.